#include <assert.h>
#include <stdio.h>
#include "IOP_PadMan.h"
#include "PS2VM.h"

using namespace IOP;
using namespace Framework;

CPadMan::CPadMan()
{
	m_pPad = NULL;
}

void CPadMan::Invoke(uint32 nMethod, void* pArgs, uint32 nArgsSize, void* pRet, uint32 nRetSize)
{
	if(nMethod != 1)
	{
		assert(0);
	}
	switch(((uint32*)pArgs)[0])
	{
	case 0x80000100:
		Open(pArgs, nArgsSize, pRet, nRetSize);
		break;
	default:
		//assert(0);
		break;
	}
}

void CPadMan::SaveState(CStream* pStream)
{

}

void CPadMan::LoadState(CStream* pStream)
{

}

void CPadMan::SetButtonState(unsigned int nPadNumber, CPadListener::BUTTON nButton, bool nPressed)
{
	uint16 nStatus;
	if(m_pPad == NULL) return;
	nStatus = (m_pPad[1].nData[2] << 8) | (m_pPad[1].nData[3]);
	
	nStatus &= ~nButton;
	if(!nPressed)
	{
		nStatus |= nButton;
	}

	m_pPad[1].nData[2] = (uint8)(nStatus >> 8);
	m_pPad[1].nData[3] = (uint8)(nStatus >> 0);
}

void CPadMan::Open(void* pArgs, uint32 nArgsSize, void* pRet, uint32 nRetSize)
{
	uint32 nPort;
	uint32 nSlot;

	nPort = ((uint32*)pArgs)[1];
	nSlot = ((uint32*)pArgs)[2];
	m_pPad = (PADDATA*)(CPS2VM::m_pRAM + ((uint32*)pArgs)[4]);

	printf("IOP_PadMan: Opening device on port %i and slot %i.\r\n", nPort, nSlot);

	m_pPad[0].nFrame		= 0;
	m_pPad[0].nState		= 6;
	m_pPad[0].nReqState		= 0;
	m_pPad[0].nLenght		= 32;

	m_pPad[1].nFrame		= 1;
	m_pPad[1].nState		= 6;
	m_pPad[1].nReqState		= 0;
	m_pPad[1].nLenght		= 32;

	//Returns 0 on error
	((uint32*)pRet)[3] = 0x00000001;
}
