#ifndef _VIF_H_
#define _VIF_H_

#include "Types.h"
#include "Stream.h"
#include "MIPS.h"

class CVIF
{
public:
	static void		Reset();
	static void		SaveState(Framework::CStream*);
	static void		LoadState(Framework::CStream*);

	static uint32	ReceiveDMA1(uint32, uint32);

	static uint32*	GetTop1Address();

	static void		StopVU(CMIPS*);
	static void		ProcessXGKICK(uint32);

	static bool		IsVU1Running();

private:
	static void		ProcessPacket(uint32, uint32, unsigned int);

	static uint32	UnpackV45(uint32, uint32, uint32, bool, uint8, uint8, uint8*);
	static uint32	UnpackV432(uint32, uint32, uint32, bool, uint8, uint8, uint8*);
	static uint32	LoadMicro(uint32, uint32, uint32, uint8*);
	static void		ExecuteMicro(CMIPS*, uint32, uint32);

	enum STAT_BITS
	{
		STAT_VBS0	= 0x0001,
		STAT_VBS1	= 0x0100,
	};

	enum STAT1_BITS
	{
		STAT1_DBF = 0x80,
	};

	static uint32	m_VPU_STAT;

	//VIF0 registers
	static uint32	m_VIF0_CYCLE;

	//VIF1 registers
	static uint32	m_VIF1_STAT;
	static uint32	m_VIF1_CYCLE;
	static uint32	m_VIF1_BASE;
	static uint32	m_VIF1_TOP;
	static uint32	m_VIF1_TOPS;
	static uint32	m_VIF1_OFST;
};

#endif
