#ifndef _IOP_PADMAN_H_
#define _IOP_PADMAN_H_

#include "IOP_Module.h"
#include "PadListener.h"

namespace IOP
{
	class CPadMan : public CModule, public CPadListener
	{
	public:
							CPadMan();
		virtual void		Invoke(uint32, void*, uint32, void*, uint32);
		virtual void		SaveState(Framework::CStream*);
		virtual void		LoadState(Framework::CStream*);
		virtual void		SetButtonState(unsigned int, CPadListener::BUTTON, bool);

		enum MODULE_ID
		{
			MODULE_ID = 0x8000010F
		};

	private:
		struct PADDATA
		{
			uint32			nFrame;
			uint8			nState;
			uint8			nReqState;
			uint8			nOk;
			uint8			nReserved0;
			uint8			nData[32];
			uint32			nLenght;
			uint32			nReserved1[5];
		};

		PADDATA*			m_pPad;

		void				Open(void*, uint32, void*, uint32);
	};
}


#endif
